
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W5100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
#include "mqtt_client.h"

#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11


char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";

uint8_t buff[2048];
uint8_t buff1[2048];
uint8 reboot_flag = 0;
CONFIG_MSG ConfigMsg;

/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
  /***Init system****/							  
	Systick_Init(72);	
	TimerInit();
	USART1_Init(); 		
	GPIO_Configuration();
	
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_
	
	FSMC_Init();

#else	
	
	WIZ_SPI_Init();
	
#endif
	
	/***** reset 6100*****/
	Reset_W6100();
	
	/***** set net *****/
	Set_Network();		

  
  while (1)
  {
        
   mqtt_client(0,AS_IPV4);
    
  }
	
	
}




